SystemOrganization addCategory: #'XML-Parser-GTExtensions'!

XMLWriter subclass: #XMLHighlightingWriter
	instanceVariableNames: 'highlights'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions'!

!XMLHighlightingWriter commentStamp: 'monty 9/21/2015 06:39' prior: 0!
This class is an XMLWriter that can make highlighted text output with XMLHighlightingPrettyPrintingWriterFormatter.!

!XMLHighlightingWriter class methodsFor: 'instance creation' stamp: 'monty 9/21/2015 06:41'!
on: aStream
	^ (super on: aStream) formatter: XMLHighlightingPrettyPrintingWriterFormatter new! !

!XMLHighlightingWriter methodsFor: 'private ' stamp: 'monty 9/21/2015 06:45'!
addHighlight: aHighlight
	^ highlights addLast: aHighlight! !

!XMLHighlightingWriter methodsFor: 'converting' stamp: 'monty 9/21/2015 06:45'!
asHighlightedText
	| text |

	text := self asString asText.
	highlights do: [:each | each applyToText: text].
	^ text.! !

!XMLHighlightingWriter methodsFor: 'private ' stamp: 'monty 9/28/2015 04:59'!
highlights
	^ highlights! !

!XMLHighlightingWriter methodsFor: 'initialization' stamp: 'monty 9/20/2015 01:11'!
initialize
	super initialize.

	highlights := OrderedCollection new.! !

!XMLHighlightingWriter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:52'!
position
	^ stream position! !

!XMLNodeWithElements class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode nodes! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:25'!
gtSpotterAllElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'All elements';
		allCandidates: [self allElements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:25'!
gtSpotterDirectElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'Direct elements';
		allCandidates: [self elements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 23:16'!
spotterPreviewSourceIn: aComposite
	<spotterPreview: 10>
	
	aComposite text
		title: 'Source';
		display: [
			self asHighlightedTextWrittenWith: [:writer |
				"use less indent for spotter previews"
				writer formatter indentString: '  '.
				self writeXMLOn: writer]];
		entity: self! !

!ZnStringEntity methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 5/8/2015 23:03'!
gtInspectorXmlIn: composite
	<gtInspectorPresentationOrder: 40>
	| xml |
	xml := [XMLDOMParser parse: self string]
		on: XMLParserException
		do: [ ^ self ].
	(xml gtInspectorTreeIn: composite)
		title: 'XML'! !

XMLPrettyPrintingWriterFormatter subclass: #XMLHighlightingPrettyPrintingWriterFormatter
	instanceVariableNames: 'xmlDeclarationColor doctypeDeclarationColor declarationColor piColor entityReferenceColor commentColor tagColor cdataColor quotedStringValueColor defaultHighlight xmlDeclarationHighlight doctypeDeclarationHighlight declarationHighlight piHighlight entityReferenceHighlight commentHighlight tagHighlight cdataHighlight quotedStringValueHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions'!

XMLHighlightingPrettyPrintingWriterFormatter class
	instanceVariableNames: 'defaultDefaultColor defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLHighlightingPrettyPrintingWriterFormatter commentStamp: 'monty 9/21/2015 06:43' prior: 0!
This formatter adds highlights to XMLHighlightingWriter output.!

XMLHighlightingPrettyPrintingWriterFormatter class
	instanceVariableNames: 'defaultDefaultColor defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:26'!
defaultCDataColor
	^ defaultCDataColor
		ifNil: [defaultCDataColor := self textColorForShoutProperty: #primitive]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:26'!
defaultCDataColor: aTextColor
	defaultCDataColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:26'!
defaultCommentColor
	^ defaultCommentColor
		ifNil: [defaultCommentColor :=  self textColorForShoutProperty: #comment]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultCommentColor: aTextColor
	defaultCommentColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/28/2015 04:39'!
defaultDefaultColor
	^ defaultDefaultColor
		ifNil: [defaultDefaultColor := self textColorForShoutProperty: #default]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/28/2015 04:39'!
defaultDefaultColor: aTextColor
	defaultDefaultColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultEntityReferenceColor
	^ defaultEntityReferenceColor
		ifNil: [defaultEntityReferenceColor := self textColorForShoutProperty: #character]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultEntityReferenceColor: aTextColor
	defaultEntityReferenceColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultPrimaryMarkupColor
	^ defaultPrimaryMarkupColor
		ifNil: [defaultPrimaryMarkupColor := self textColorForShoutProperty: #argument]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultPrimaryMarkupColor: aTextColor
	defaultPrimaryMarkupColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultQuotedStringValueColor
	^ defaultQuotedStringValueColor
		ifNil: [defaultQuotedStringValueColor := self textColorForShoutProperty: #string]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultQuotedStringValueColor: aTextColor
	defaultQuotedStringValueColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultSecondaryMarkupColor
	^ defaultSecondaryMarkupColor
		ifNil: [defaultSecondaryMarkupColor := self textColorForShoutProperty: #self]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultSecondaryMarkupColor: aTextColor
	defaultSecondaryMarkupColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'class initialization' stamp: 'monty 9/28/2015 04:38'!
initialize
	"self initialize"

	self
		defaultDefaultColor: nil;
		defaultPrimaryMarkupColor: nil;
		defaultSecondaryMarkupColor: nil;
		defaultQuotedStringValueColor: nil;
		defaultEntityReferenceColor: nil;
		defaultCommentColor: nil;
		defaultCDataColor: nil! !

XMLHighlightingPrettyPrintingWriterFormatter initialize!

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'private' stamp: 'monty 9/22/2015 00:07'!
textColorForShoutProperty: aShoutProperty
	^ TextColor color:
		(((SHTextStylerST80 new attributesFor: aShoutProperty)
			detect: [:each | each respondsTo: #color]
			ifNone: [^ nil]) color)! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 02:58'!
cdataColor
	^ cdataColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 02:58'!
cdataColor: aTextColor
	cdataColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
commentColor
	^ commentColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:17'!
commentColor: aTextColor
	commentColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
declarationColor
	^ declarationColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:17'!
declarationColor: aTextColor
	declarationColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/28/2015 04:33'!
defaultColor
	^ defaultHighlight color! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/28/2015 04:33'!
defaultColor: aTextColor
	defaultHighlight color: aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
doctypeDeclarationColor
	^ doctypeDeclarationColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:19'!
doctypeDeclarationColor: aTextColor
	doctypeDeclarationColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private ' stamp: 'monty 9/20/2015 01:55'!
endHighlight: aHighlight
	aHighlight
		ifNotNil: [aHighlight end: self writer position]! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
entityReferenceColor
	^ entityReferenceColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:19'!
entityReferenceColor: aTextColor
	entityReferenceColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 02:59'!
formatAfterCData: aCDataWriter
	self endHighlight: cdataHighlight.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 21:46'!
formatAfterCharacterEscape: aCharacterEscape
	self endHighlight: entityReferenceHighlight.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:31'!
formatAfterComment: aCommentWriter
	self endHighlight: commentHighlight.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:31'!
formatAfterDeclaration: aDeclarationWriter
	self endHighlight: declarationHighlight.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:31'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	self endHighlight: doctypeDeclarationHighlight.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:33'!
formatAfterEndTag: aTagWriter
	self endHighlight: tagHighlight.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:33'!
formatAfterEntityReference: anEntityReferenceWriter
	self endHighlight: entityReferenceHighlight.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:28'!
formatAfterPI: aPIWriter
	self endHighlight: piHighlight.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:34'!
formatAfterQuotedStringValue: aString
	self endHighlight: quotedStringValueHighlight.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:34'!
formatAfterStartTag: aTagWriter
	self endHighlight: tagHighlight.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:34'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	self endHighlight: xmlDeclarationHighlight.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 02:58'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	cdataHighlight := self newHighlightColored: self cdataColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 21:46'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	entityReferenceHighlight := self newHighlightColored: self entityReferenceColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:35'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	commentHighlight := self newHighlightColored: self commentColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:35'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	declarationHighlight := self newHighlightColored: self declarationColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:37'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	doctypeDeclarationHighlight := self newHighlightColored: self doctypeDeclarationColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:36'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	self startNewTagHighlight.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:37'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	entityReferenceHighlight := self newHighlightColored: self entityReferenceColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:27'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	piHighlight := self newHighlightColored: self piColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:38'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	quotedStringValueHighlight := self newHighlightColored: self quotedStringValueColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:36'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	self startNewTagHighlight.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:38'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	xmlDeclarationHighlight := self newHighlightColored: self xmlDeclarationColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'initialization' stamp: 'monty 9/28/2015 04:34'!
initialize
	super initialize.

	self
		initializeDefaultHighlight;
		initializeColors.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'initialization' stamp: 'monty 9/28/2015 04:38'!
initializeColors
	self
		defaultColor: self class defaultDefaultColor;
		xmlDeclarationColor: self class defaultSecondaryMarkupColor;
		doctypeDeclarationColor: self class defaultSecondaryMarkupColor;
		piColor: self class defaultSecondaryMarkupColor;
		declarationColor: self class defaultPrimaryMarkupColor;
		tagColor: self class defaultPrimaryMarkupColor;
		quotedStringValueColor: self class defaultQuotedStringValueColor;
		entityReferenceColor: self class defaultEntityReferenceColor;
		commentColor: self class defaultCommentColor;
		cdataColor: self class defaultCDataColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'initialization' stamp: 'monty 9/28/2015 05:11'!
initializeDefaultHighlight
	defaultHighlight := XMLHighlight new! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private ' stamp: 'monty 9/20/2015 01:57'!
newHighlightColored: aTextColor
	^ aTextColor
		ifNotNil: [
			self writer addHighlight: 
				(XMLHighlight new
					color: aTextColor;
					start: self writer position + 1)]! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
piColor
	^ piColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
piColor: aTextColor
	piColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
quotedStringValueColor
	^ quotedStringValueColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
quotedStringValueColor: aTextColor
	quotedStringValueColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private ' stamp: 'monty 9/20/2015 01:36'!
startNewTagHighlight
	tagHighlight := self newHighlightColored: self tagColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
tagColor
	^ tagColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
tagColor: aTextColor
	tagColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/28/2015 05:00'!
writer: aWriter
	super writer: aWriter.

	aWriter addHighlight: defaultHighlight.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
xmlDeclarationColor
	^ xmlDeclarationColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
xmlDeclarationColor: aTextColor
	xmlDeclarationColor := aTextColor! !

!XMLDocument class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDOMParser parse: '<document><a></a><b></b></document>'! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 19:48'!
hasTreeNodeChildren
	^ self hasChildren
		or: [self hasDoctypeDeclaration]! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 19:56'!
treeNodeChildren
	self hasDoctypeDeclaration
		ifTrue: [^ self nodes copyWithFirst: self doctypeDeclaration]
		ifFalse: [^ self nodes]! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:09'!
writeTreeNodeLabelXMLOn: aWriter
	self writeXMLDeclarationOn: aWriter! !

!XMLElement class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode firstElement! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 16:48'!
formForImageEntity: imageEntity
  | imageType parserClassName parserClass parser |
  imageType := imageEntity contentType sub.
  parserClassName := imageType asUppercase, #ReadWriter.
  parserClass := Smalltalk globals at: parserClassName asSymbol.
  parser := parserClass on: imageEntity readStream.
    ^ parser nextImage! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 20:14'!
gtInspectorImageIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 40>
	|client url|
	
	(aGTInspector panes size > 1) 
		ifFalse: [ ^ self ].	
	
	client := (aGTInspector panes reversed collect: [ :each | (each port: #entity) value ])
		detect: [ :each | 
			(each isKindOf: ZnClient)
				and: [each request notNil]]
		ifNone: [ ^ self ].
	url := client request absoluteUrl.
	
	^ composite morph 
		title: 'Image';
		display: [ 
			self formForImageEntity:
				(ZnClient new 
      				beOneShot;
      				get: url/ (self attributeNodes attributeValueAt: 'src');
      				entity)];
		when: [ self name = 'img' and: [(self attributeNodes attributeValueAt: 'src') notNil]]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 19:13'!
hasTreeNodeChildren
	^ self hasChildren
		and: [self nodes size > 1
			or: [self nodes first isStringNode not]]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 18:48'!
treeNodeChildren
	self hasTreeNodeChildren
		ifTrue: [^ self nodes]
		ifFalse: [^ #()]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:09'!
writeTreeNodeLabelXMLOn: aWriter
	self hasTreeNodeChildren
		ifTrue: [
			aWriter startTag
				name: self name;
				setAttributes: attributes]
		ifFalse: [| tagWriter |
			(tagWriter := aWriter tag)
				name: self name;
				setAttributes: attributes.
			self hasChildren
				ifTrue: [tagWriter with: [self writeInnerXMLOn: aWriter]]].! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 22:42'!
asHighlightedText
	^ self asHighlightedTextWrittenWith: [:writer | self writeXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 22:42'!
asHighlightedTextWrittenWith: aBlock
	| writer |

	writer := XMLHighlightingWriter new.
	self escapesContentEntitiesWhenWriting
		ifFalse: [writer escapesContentEntityReferences: false].
	aBlock value: writer.
	^ writer asHighlightedText.! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 21:02'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 40>

	"removed unfinished source panel editing support for now"
	composite text 
		title: 'Source';
		format: #asHighlightedText! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 21:02'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite tree
		title: 'Tree';
		display: [ {self} ];
		children: #treeNodeChildren;
		format: #treeNodeLabelText;
		when: [self hasTreeNodeChildren];
		rootsExpanded! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 18:19'!
hasTreeNodeChildren
	^ self hasChildren! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 17:12'!
treeNodeChildren
	^ #()! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 22:42'!
treeNodeLabelText
	^ self asHighlightedTextWrittenWith: [:writer | self writeTreeNodeLabelXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:09'!
writeTreeNodeLabelXMLOn: aWriter
	self writeXMLOn: aWriter! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:25'!
gtSpotterXMLDocumentFor: aStep
	<spotterOrder: 40>
	self extension = 'xml' ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'XML document';
		allCandidates: [ (XMLDOMParser parse: self) allElements ];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLDoctypeDeclaration methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:33'!
writeTreeNodeLabelXMLOn: aWriter
	aWriter lineBreak: ''. "suppress blank line after doctype"
	aWriter doctype
		root: self root;
		publicID: self publicID;
		systemID: self systemID.! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 17:12'!
treeNodeChildren
	^ self nodes! !

Object subclass: #XMLHighlight
	instanceVariableNames: 'color start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions'!

!XMLHighlight commentStamp: 'monty 9/21/2015 04:24' prior: 0!
This class stores a highlight TextColor and 1-based start/end highlight positions.!

!XMLHighlight methodsFor: 'highlighting' stamp: 'monty 9/28/2015 05:24'!
applyToText: aText
	| attributeStart attributeEnd |

	attributeStart := self start ifNil: [1].
	attributeEnd := self end ifNil: [aText size].
	attributeStart < attributeEnd
		ifTrue: [
			aText
				addAttribute: self color
				from: attributeStart
				to: attributeEnd].! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
color
	^ color! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
color: aTextColor
	color := aTextColor! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
end
	^ end! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
end: anEndPosition
	end := anEndPosition! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
start
	^ start! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
start: aStartPosition
	start := aStartPosition! !

XMLHighlightingPrettyPrintingWriterFormatter initialize!
